RetroLib - Bug #16

Error en 03_holaROM
09/09/2013 03:38 AM - Txinto Vaz

Status: Closed Start date: 09/09/2013
Priority: Normal Due date:

Assignee: Txinto Vaz % Done: 100%
Category: Estimated time: 0.00 hour
Target version: v0.0.1 Spent time: 6.00 hours
Description

Al intentar compilar el proyecto segun el tutorial nos da un error y la ROM generada no funciona:

$ sdcc —mz80 —--no-std-crt0 —--code-loc 0x4010 —--data-loc 0xC000 HelloSC2.c
Warning: z80instructionSize () failed to parse line node 1ld sp, (#0xFC4A)

HelloSC2.c:131: warning 85: in function mainWindow unreferenced local variable : 'size'
HelloSC2.c:131: warning 85: in function mainWindow unreferenced local variable : 'address'
HelloSC2.c:131: warning 85: in function mainWindow unreferenced local variable : 'i'
HelloSC2.c:190: warning 59: function 'vpeek' must return value

HelloSC2.c:227: warning 59: function 'inkey' must return value

HelloSC2.c:239: warning 59: function 'peek' must return value

$ hex2bin HelloSC2.ihx
hex2bin v1.0.10, Copyright (C) 2012 Jacques Pelletier & contributors

Lowest address = 00004010

Highest address 00004D3A

Pad Byte = FF

8-bit Checksum = 6F

$ mv HelloSC2.bin HelloSC2.rom

$ openmsx HelloSC2.rom

Fatal error: Error in "ROM" extension: (uncompressed) ROM image filesize must be a multiple of 8 k
B (for this mapper type).

$ 1s -la

total 216

drwxrwxr-x. 2 txinto txinto 4096 sep 9 05:35

drwxrwxr-x. 3 txinto txinto 4096 sep 5 22:06 ..
—rw-rw-r——. 1 txinto txinto 27593 sep 9 05:33 HelloSC2.asm
—rw-rw-r——. 1 txinto txinto 6060 sep 9 05:25 HelloSC2.c
-rw-rw-r——. 1 txinto txinto 8026 sep 9 05:33 HelloSC2.ihx
-rw—-rw-r——. 1 txinto txinto 152 sep 9 05:33 HelloSC2.1lk
—-rw—rw-r-—. 1 txinto txinto 87706 sep 9 05:33 HelloSC2.lst
—-rw—-rw-r—-—. 1 txinto txinto 4282 sep 9 05:33 HelloSC2.map
—-rw-rw-r—-—. 1 txinto txinto 1172 sep 9 05:33 HelloSC2.noi
—rw-rw-r——. 1 txinto txinto 17972 sep 9 05:33 HelloSC2.rel
—rw-rw-r——. 1 txinto txinto 3371 sep 9 05:34 HelloSC2.rom
—rw-rw-r——. 1 txinto txinto 16384 sep 5 22:28 HelloSC2.rom2
-rw-rw-r——. 1 txinto txinto 16384 abr 13 2010 HelloSC2.rom.old
—-rw—rw-r——. 1 txinto txinto 3913 sep 9 05:33 HelloSC2.sym

En el listado final, HelloSC2.rom es lo que acabamos de generar, rom2 es el que (creo) que compilé el otro dia sin problemas, y
rom.old es el que venia con el ejemplo.

¢Alguna idea?
La frase: (al resultado faltaria aplicarle el hex2bin y convertirlo en una ROM de 16k)

¢convertirlo en una ROM de 16k es algun tipo de proceso que no conozco? Si eso fuera asi, seguramente tuve un error el otro dia y
ese rom2 no lo generé yo, sino que seguramente lo copié sad.png

History

#1 - 09/09/2013 03:46 AM - Txinto Vaz

He descubierto las opciones de hex2bin, pero me sale un fichero de 16368 en vez de uno de 16384:
$ hex2bin -1 4000 HelloSC2.ihx
hex2bin v1.0.10, Copyright (C) 2012 Jacques Pelletier & contributors

Lowest address = 00000010

Highest address = 00003FFF

Pad Byte = FF

8-bit Checksum = AA

$ 1s -la

total 228

drwxrwxr—-x. 2 txinto txinto 4096 sep 9 05:43

drwxrwxr-x. 3 txinto txinto 4096 sep 5 22:06 ..
—rw-rw-r——. 1 txinto txinto 27593 sep 9 05:33 HelloSC2.asm
-rw-rw-r——. 1 txinto txinto 6060 sep 9 05:25 HelloSC2.c
—-rw-rw-r——. 1 txinto txinto 8026 sep 9 05:33 HelloSC2.ihx
-rw-rw-r——. 1 txinto txinto 152 sep 9 05:33 HelloSC2.1lk
-rw-rw-r——. 1 txinto txinto 87706 sep 9 05:33 HelloSC2.lst
—-rw-rw-r——. 1 txinto txinto 4282 sep 9 05:33 HelloSC2.map
—rw-rw-r——. 1 txinto txinto 1172 sep 9 05:33 HelloSC2.noi
—-rw-rw-r——. 1 txinto txinto 17972 sep 9 05:33 HelloSC2.rel
—-rw-rw-r——. 1 txinto txinto 16368 sep 9 05:44 HelloSC2.bin
-rw-rw-r-—. 1 txinto txinto 16384 sep 5 22:28 HelloSC2.rom2
-rw-rw-r-—. 1 txinto txinto 16384 abr 13 2010 HelloSC2.rom.old
—-rw-rw-r——. 1 txinto txinto 3913 sep 9 05:33 HelloSC2.sym

#2 - 09/09/2013 04:31 AM - Txinto Vaz
- File nova.png added
- File siva.png added

He visto la web de Nerlaska, y sus instrucciones.

http://www.nerlaska.com/msx/PROGRAMAR_MSXROMS_CON_SDCC.rar

(las afnado a la seccion documentos como document#2)
El hace lo siguiente:

1. hex2bin del fichero
2.lo concatena detras de rom_header.bin
3. lo rellena hasta 16384 bytes con una aplicacion de él mismo.

El paso 3 ya lo estoy haciendo (creo) con el hex2bin

hex2bin -1 4000 HelloSC2.ihx
hex2bin v1.0.10, Copyright (C) 2012 Jacques Pelletier & contributors

Lowest address 00000010
Highest address 00003FFF
Pad Byte = FF
8-bit Checksum = AA

Ahora el tamafio es el que dije antes:

$ 1s -la *.bin
—-rw-rw-r——. 1 txinto txinto 16368 sep 9 06:19 HelloSC2.bin
-rw-rw-r-—-. 1 txinto txinto 16 sep 9 06:09 rom_header.bin

Si lo vuelco veo que ha rellenado por el final:

$ cat HelloSC2.bin
?27222%@27M?22!129! (?9?2!192>2kb#62kb##62kb###62!62!162!62!162672! 62!
67!
67!

62162162!162!162!162!162!62!62!62!162!162!62!162!162!162!162!162162! 62!162!"62!462!1562!1%62!1&62!'62! (62!)62!*62!+62!,62!—
62!.62!/621062!1162!1262!1362!1462!562!1662!1762!1862!1962!:62!;62!<62!=62!1>621262!Q62!A62!B62!C62!D62!E6?!F62!G62!H6?
1762!1J6?!K62! 162 !M62!N62!06?!P62!Q62!R62!562!T62!1U62!V62!W6?2!X62!Y62!1762![62!\62!]162!762!_62!62!a6?!b62!c6?!d
621e62!f62!1g62!h62!162!362!k62!162!m62!'n62!1062!p62!q62!r62!562!t62!u6?2!v62!w6?2!x62!y62!262!{62![62!}162!~62!10672
126212621262126212621262!1262!12621262!1262!1262!1262!12621262! 62! 62!12621262!1262!1262!1262!1262!1262!1262!1262!1262!1262!°?
6212621262126212621262!1262!1262!12621262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1267
126212621262126212621262!1262!12621262!12621262!1262!1262!1262!1262!1262!12621262!1262!1262!1262!1262!1262!1262!12621262!1262!7?
6212621262126212621262!1262!1262!1262126212621262!1262!1262!1262!1262!12621262!1262!1262!1262!1262!1262!1262!1262!1262!1262!12672
http://www.nerlaska.com/msx/PROGRAMAR_MSXROMS_CON_SDCC.rar

G2
672!

62!671672!1672!1672!1672!162!1672!162!162!162!162!167!162!67!162!672!1672!167! 62!162!"62!#62!1562!1%62!1&62!'672! (672!)672!*62!1+62!,62!—
62!1.62!1/621067!1162!262!13671467!1562!1662!1762!1862!1962!:62!;62!<62!=62!>62!1267!Q@67!A67?!B6?!C6?!D6?!E6?!F6?!G67!H6?
1162!J62!K62!L62!IM62!N62!1067!P62!0Q62!R62!S562!T62!1U6?!V62!IW6?!X62!Y62!1Z62![62!\62!]62!762!_62!"621a62!b6?!c6?!d
621e6?2!£6?!g62!h62!162!362!1k62!162!m6?!n6?!062!p62!g62!r62!s62!t6?2!ub?!ve?!we?!x62!y6?2!262!{62!]62!}162!~62!06?
1262126217267 267 1262126217267 P67 176712621267 I P6RI P67 126 16R16R176R 267 126R 1262 1726R 267 1 P6R 12621267 67 1 967 1267
1262!12672!17267!172671262!1262!12672!1726721767!17672!17262!1262!1262!1262!262!1262!17262!262!1262!262!262!7267!7267!17267!17262!172672!17267!7

6212621262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!7267

?7?!

..... (como vemos ha rellenado al final)
PRV 222222222222°2272°

Ahora concateno y vuelvo a comprobar

$ cat rom_header.bin

ABQ

$ cat rom_header.bin HelloSC2.bin > HelloSC2_1.rom
$ cat HelloSC2_1.rom

?27222%@27M??22!129! (?292!197>?kb#6?kb##6?kb###62!162!162!162!167267! 672!
672!
612!

62162!162162162!162167!62162!1672!162!162162!162!162!162!162!162!162! 62!1162!"62!4#67!15672!%621&62!'62! (62!)62!*62!1+67!,67!-
621.62!/621062!162!262!1362!1462!1562!1662!762!862!1962!:62!;62!<62!=62!>62!1262!0@62!A6?!B6?!C6?!D6?!E6?!F6?!G6?!H6?
1162!J62!K62!L62!M62!N62!062!P62!10Q062!R62!S62!T62!U62!V62!W62!X62!1Y62!1262![62!\62!]62!1762!_62!"62!'a6?!b6?!c6?!d
621e6?2!£6?2!g672!h62!162!362!1k62!16?!m6?!n6?!06?!p62!g62!r62!s62!t6?2!ub?!v6?!we?!x6?2!y6?2!262!{62!62!}62!~62!067
1262!12672!17267!1726717262!1262!12672!1726721767217267217262!1262!1262!1262! 62! 62!7262!262!262!262!262!2672!7267!17267!17262!17262!17267!7
6212672 12621262126212621262 1262 1262 11262 1262262 262 2621 267 1 26212621 26212621 2621267272672 72672!72672!7262!262126212672
126212621767 267 1262126217267 767 176712621267 I P6R I P67 12621262167 I P67 1767 126R 12671 P67 1767 2GR 12671267 1767 2GR 7
621262!1262!1262!1262!1262!1262!262!17267!17267!17267!17262!17262!172672!1726721767!1767217262!1262!1262!1262!262!262!7262!7262!262!26?2!7267?
26z lizez iRerlllRie e e 262262 267212621 26212621 26217262!72672!17262!7262!1262672!162162!62!162!162162!6262! 612!

G2

672!

62!671672!1672!1672!1672!162!1672!162!162!162!162!167!162!67!162!672!1672!167! 62!162!"62!#62!1562!1%62!1&62!'672! (672!)672!*62!1+62!,62!—
62!1.62!1/621067!1162!262!13671467!1562!1662!1762!1862!1962!:62!;62!<62!=62!>62!1262!Q@67!A67?!B6?!C6?!D6?!E6?!F6?!G67!H6?
1162!J6?2!K62!L62!M62!N62!1067!P62!062!IR62!S562!T62!1U6?!V62!IW6?!X62!Y62!1Z62![62!\62!]62!762!_62!"62!a62!b6?!c6?!d
621e6?2!£6?!g62!h62!162!J62!1k62!162!m6?!n6?!062!p62!9g62!r62!s62!t6?2!ub?!ve?!we?!x62!y62!262!{62!]62!}162!~62!06?
1262126217267 267 1262126217267 P67 176712621267 I P6RI P67 126 16R16R176R 267 126R 1262 1726R 267 1 P6R 12621267 67 1 967 1267
1262!12672!17267!1726717262!1262!1262!17267217672172672!17262!1262!1262!1262!262!12672!17262!1262!262!262!262!7267!7267!17267!17262!172672!17267!7

6212621262!12621262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!1262!262!1262!1262!7267

?7?!

(y asi hasta el final)
Parece que lo ha hecho bien!

Sin embargo el programa no funciona

$ openmsx HelloSC2_1.rom
openMSX 0.9.0 - C-BIOS MSX2+

openMSX 0.9.0 - C-BIOS MSX2+

HEL: ¢ MOl I3

FEiPE 7= FELFRSERLIE

#3 - 09/09/2013 04:42 AM - Txinto Vaz

Descartado que sea el paso del hex2bin o el paso a 16k (que parece estar bien) todo apunta a que el problema se da durante la compilacién. La
version del SDCC que estoy usando es la 3.2.0.

Aqui tenemos un volcado (entero) del original:

$ cat HelloSC2_orig.rom
Y aqui s6lo un trozo del generado por mi:

$ cat HelloSC2_1.rom

?22722%@27M??2!129! (292!197>7kb#6°kb##6°kb###62!162!162!162!16267! 672!
612!
G2

62!162162!162!162!162!162!162!162!162!162162!62162!1672!162!162!162!162! 62!1162!1"62!#62!1$62!1%62!1&62!'62! (62!)62!*62!1+62!,672!—
62!.62!1/621062!162!262!1367!1462!1562!1662!1762!1862!1962!:62!;62!<62!=62!>62!262!0Q67!A67?!B6?!C6?!D6?!E6?!F6?!G67!H6?
1162!J67!K6?!L672!M62!N62!062!P62!1Q62!R62!S62!T62!U62!V62!W62!X62!1Y62!1262![62!\62!]62!1767!_62!"62!a6?!b6?!c6?!d
621e62!£62!1g62!h6?2!162!J62!k62!162!m62!n62!1062!p62!g62!r6?2!s62!t62!ub?!ve?!we?!x6?2!y62!1262!{62!(62!}162!~62!10672
26 liz6z iRier e 62 62 262 262 26212621 2621 262126212621 672! 621726212621 2621262!1262 112672 1126211262 1126211262/ 262112
GriZE7 17671767 126212671267 1767 26 126R126% 1767 26712621262 176R I 267 176712621267 I PER I P67 1267126212671 P67 172671267
1262!12672!17267!172671262!1262!12672!17267217672172672!17262!1262!1262!1262!262!12672!17262!262!1262!262!2672!267!7267!7267!17262!172672!17267!7
621267212621 262126212621262 1262 1262 11262 1262 262 262 2621267 1 26212621 26212621 262126272672 72672!7262!7262!262126212672
1262126217267 2671 76R 126212671267 1926712621262 1R6RIP6% 1267 126R 12671267 1767167 16R16R16% 167 16716716267 6!

672!

612!

62162!162162162!162167!62162!1672!162!162162!162!162!162!162!162!162! 62!1162!"62!4#67!15672!%621&62!'62! (62!)62!*62!1+67!,67!-
621.62!/621062!162!262!1362!1462!1562!1662!762!862!1962!:62!;62!<62!=62!>62!1262!0@62!A6?!B6?!C6?!D6?!E6?!F6?!G6?!H6?
1162!J62!K62!L62!M62!N62!062!P62!10Q062!R62!S62!T62!U62!V62!W62!X62!1Y62!1262![62!\62!]62!1762!_62!"62!'a6?!b6?!c6?!d
621e6?2!£6?2!g672!h62!162!362!1k62!16?!m6?!n6?!06?!p62!g62!r62!s62!t6?2!ub?!v6?!we?!x6?2!y6?2!262!{62!62!}62!~62!067
1262!12672!17267!172671262!1262!12672!17267217672!172672!17262!1262!1262!1262!62!162!7262!17262!262!262!262!2672!7267!7267!17267!1262!172672!1767
262 liz67 26 llRie 2 Rie2 62 262 262 1 267212621 2621 262126212621 72672!72672!7262!1262!26212621262 11267211262 11262 1126211262/ 262112

62!1262!1262!12672!1262!1262!1262!1262!2672!17267!17267!17267!172672!172672!172672!17267217262!1262!1262!1262!1262!1262!1262!1262!17262!262!1262!7267

Parece como si un programa careciera de un final de fichero que otro si tiene (recordemos que tienen la misma longitud)

1$ 1s -la *.rom
—-rw-rw-r——. 1 txinto txinto 16384 sep 9 06:24 HelloSC2_1l.rom
—rw-rw-r——. 1 txinto txinto 16384 abr 13 2010 HelloSC2_orig.rom

Pero, aparte de eso, el cddigo generado por mi tiene mucho mas codigo al principio antes de llegar a la frase HELLO HORLD!HOLA MUNDOL.

#4 - 09/09/2013 07:33 PM - Txinto Vaz
- File temp_HelloSC2_zip added
- Assignee changed from aorante mvac? to Txinto Vaz

- % Done changed from 0 to 50

Después de todas las pesquisas, revisar la informacion, etc... hemos llegado a la conclusién de que ha habido cambios entre la versién usada en su
dia por Alberto (2.9.7) y la actual de la distribucion oficial de Fedora (3.2.0). Habra que ver si se debe a algin tipo de error corregido en la mas
nueva (3.3.0) o de un cambio pensado para quedarse. En éste Ultimo caso deberiamos actualizar el cédigo fuente.

A continuacién pego extractos de la conversacion mantenida con Alberto via e-mail:

El sistema de Nerlaska, que es el que utilizo yo, en realidad es el mds engorroso por que hay que afladir exter
namente la cabecera de la ROM que son 1l6Bytes:

DEFB "AB" ; expansion ROM header

DEFW initcode ; start of the init code, 0 if no initcode

DEFW callstat; pointer to CALL statement handler, 0 if no such handler

DEFW device; pointer to expansion device handler, 0 if no such handler

DEFW basic ; pointer to the start of a tokenized basicprogram, 0 if no basicprogram
DEFS 6,0 ; room reserved for future extensions

http://www.msx.org/forum/msx-talk/general-discussion/header-rom-cartridge

Ha de empezar con "AB" y luego ha de tener el initcode que es la direccidén de ejecucidn de nuestro programa. E
1 resto si no se utiliza ha de ser ceros.

si utilizas un startup te ahorras todo esto. Cuando hizo el tutorial Nerlaska no se habian creado los startups
para ROMs.

http://msx.atlantes.org/sdcc_msx/msxsdcc03.zip
Una vez compilado, lo que faltard es ampliar el fichero al tamafio de ROM exacto.
Alberto
El tema es si a ti también te daba el warning g dice algo como can no parse 1ld (#0x4...)
He mirado los binarios resultantes y creo g mi ihx es muy diferente al g te debidé salir a ti.
TG podrias enviarme tu ihx para compararlo? Puede haber diferencias entre tu versidén de sdcc y la mia? 3.2.0
Txinto
Warning: z80instructionSize () failed to parse line node 1d sp, (#0xFC4A)
se corresponde al cdédigo:
__asm
di
1d sp, (#0xFC4A)
el
__endasm;
habrédn cambiado algo relacionado con el inline assembler... :P
He mirado los binarios resultantes y creo g mi ihx es muy diferente al g te debid salir a ti.
te mando los ficheros de salida.
TG podrias enviarme tu ihx para compararlo? Puede haber diferencias entre tu versidén de sdcc y la mia? 3.2.0
yo utilizo la 2.9.7
la Gltima es la versidén 3.3.0
probé con la ultima pero me dio problemas con mi GUI. Yo redirecciono la salida a un fichero que luego leo y m
uestro en una caja del GUI. Parece que no funciona y la GUI se queda bloqueada esperando el fichero. Tengo pen
diente buscar una solucién...

Alberto

Muchas gracias, voy a ver si con tu ihx funciona mi copypaste, y luego voy a ver g han cambiado y te informo d
el resultado. Un saludo!!!

Txinto

Comprobado, es el compilador, he hecho los pasos a partir del ihx y ha funcionado como una seda. En cuanto te
nga un rato lo documento y asi ya sabes hacer ROMs a la Nerlaska con aroma de Linux o Mac.

Un saludo!

Tx.
#5 - 09/09/2013 07:51 PM - Txinto Vaz

Investigando en: http:/sourceforge.net/p/sdcc/bugs/2142/#328d

Vemos lo siguiente:

The issue with 1d is fixed in revision #8451. The issue with uppercase asm remains.
Philipp

Nosotros estamos probando la version 3.2.0 #8008, o sea que seguramente es un bug que se arregla instalando la versién mas nueva. Lo
intentaremos a continuacion.

#6 - 09/09/2013 08:26 PM - Txinto Vaz

Hemos instalado el 3.3.0, probamos a ver la compilacion:

$ make
sdcc -D_MSX_CROSS_COMPILER -mz80 --no-std-crt0 --code-loc 0x4010 —--data-loc 0xC000 -I ..-I ../../../retro
lib/computers/msx/system/include -I ../../../retrolib/computers/msx/targets/rom/include -I ../../../retrolib/c
omputers/msx/versions/msxl/include -I ../../../retrolib/cpus/z80/include -I /usr/share/sdcc/include -0 Hello
SC2.ihx ../src/HelloSC2.c
./src/HelloSC2.c:131: warning 85: in function mainWindow unreferenced local variable : 'size'
./src/HelloSC2.c:131: warning 85: in function mainWindow unreferenced local variable : 'address'
./src/HelloSC2.c:131: warning 85: in function mainWindow unreferenced local variable : 'i'
../src/HelloSC2.c:190: warning 59: function 'vpeek' must return value
../src/HelloSC2.c:227: warning 59: function 'inkey' must return value
./src/HelloSC2.c:239: warning 59: function 'peek' must return value

$ hex2bin -1 4000 HelloSC2.ihx
hex2bin v1.0.10, Copyright (C) 2012 Jacques Pelletier & contributors

Lowest address 00000010
Highest address = 00003FFF
Pad Byte = FF

8-bit Checksum = 97

Ya no sale el warning!
Pero sigue sin funcionar

#7 - 09/10/2013 08:26 AM - Txinto Vaz
- Status changed from New to In Progress

- % Done changed from 50 to 100

Lo tenemos!!! La clave estaba en que ha cambiado el mecanismo para asignar los registros. Por suerte han mantenido un flag que nos permite
compilar con el sistema antiguo:

—-oldralloc

Recomendamos estudiar en qué consiste el cambio. Deberia ser una mejora con respecto a lo anterior, y ser transparente para el usuario (o dar un
warning al respecto). Hay que evaluar por qué el cédigo es sensible a dicho cambio, y modificarlo. ¢Posiblemente se esté asumiendo que el
compilador va a actuar de una determinada manera? ;Puede haberse estudiado en qué registros ha colocado algo (examinando el asm generado)
para asi programar alguna de las partes de ensamblador? Si no es posible, habria que ver si es necesaria alguna directiva de compilador o linkador
para poder especificar algo que el compilador no deberia poder escoger.

#8 - 09/10/2013 08:27 AM - Txinto Vaz

- Status changed from In Progress to Resolved

#9 - 09/10/2013 08:27 AM - Txinto Vaz

- Status changed from Resolved to Closed

#10 - 09/15/2013 06:25 PM - Txinto Vaz

- Target version set to v0.0.1

#11 - 06/16/2014 10:50 AM - aorante mvac7

investigando un poco este problema, me he encontrado en los foros de Amstrad.es, con coders que han tropezado con lo mismo:
http://www.amstrad.es/forum/viewtopic.php?f=78&t=2742

el usuario Mochilote ha reportado el problema a los foros del grupo de desarrollo de SDCC:

http: rceforge.n mailman/m /2954824

El problema se encuentra en la compilacién, en la forma que utiliza para acceder a las variables en las llamadas a las funciones, que ha sido
http://sourceforge.net/p/sdcc/bugs/2142/#328d
http://www.amstrad.es/forum/viewtopic.php?f=7&t=2742
http://sourceforge.net/p/sdcc/mailman/message/29548243/

cambiado, entiendo que buscando una forma de optimizar el cédigo, pero que no acaba de funcionar bien para todos los casos...
* Many small improvements in the z80, hc08 and r2k code generation, reducing code size.

habra que tirar de --oldralloc, pero es bueno saber que estan trabajando en mejorar... smile.png
